# Notes on the documentation

Documentation is built via `sphinx`, taking advantage of the auto documentation capabilities. However, this
also requires that the in code documentation is mostly written `ReST`. Note that full markdown documents can
still be included successfully. For example, the main `README.md` is included this way.

## Linking `about.md` to the main `README.md`

It is imperative that this is a file named `about.md` to ensure that the sidebar logo and navigation shows up
properly. This is required by the alabaster theme (although it is not super well documented). For more, see
[this issue](https://github.com/bitprophet/alabaster/issues/86).

## Symlinks

A number of other READMEs and image files are symlinked to other locations in the repository. This is done to
simplify the building of the docs by ensuring that all files that are included in the docs are within the docs
directory.

## `Autodoc` modification notes

Although the documentation is generated via `autodoc`, the base files generated by `autodoc` (with the command
`sphinx-apidoc -o api ../pachyderm`) were modified for readability.

## Building on Read The Docs (RTD)

RTD doesn't support `ROOT`. Since we can't install it, we instead mock up the module. These mocks are defined
in `conf.py`. This way, we can build the docs even though ROOT isn't installed!
